﻿using LMVCallbackLib;
using System.Runtime.InteropServices;
using System;

namespace ConcatUsingCallback
{
   public class Mem
   {
      [DllImport("kernel32.dll", EntryPoint = "CopyMemory", SetLastError = false)]
      public static extern void Copy(IntPtr dest, IntPtr src, int count);
   }

   //source video callback
   public class ConvCallbkSrc : ILMVUserCallback2
   {
      public ConvCallbkSrc()
      {
      }
      ~ConvCallbkSrc()
      {

      }

      public Concatenate concat;
      private int counter = 0;
      public void ReceiveProc(long pData, int lWidth, int lHeight, int lBitCount, int lSize, int bTopDown)
      {
         if (concat.gbStop)
            return;
         while (concat.bufferReady)
            System.Threading.Thread.Sleep(1);
         counter++;
         System.Diagnostics.Debug.WriteLine("Source counter = " + counter.ToString());
         if (lSize != concat.memSize)
         {
            concat.bufferReady = true;
            return;            
         }
         IntPtr source = new IntPtr(pData);
         Mem.Copy(concat.sharedMem, source, lSize);
         System.Diagnostics.Debug.WriteLine("copied source to shared");
         concat.bufferReady = true;
      }
   }

   //target video callback
   public class ConvCallbkDest : ILMVUserCallback2
   {
      public ConvCallbkDest()
      {
      }
      ~ConvCallbkDest()
      {

      }

      public Concatenate concat;
      private int counter = 0;
      public void ReceiveProc(long pData, int lWidth, int lHeight, int lBitCount, int lSize, int bTopDown)
      {
         if (concat.gbStop)
            return;
         while (!concat.bufferReady)
            System.Threading.Thread.Sleep(1);
         counter++;
         System.Diagnostics.Debug.WriteLine("Dest counter = " + counter.ToString());
         if (lSize != concat.memSize)
         {
            concat.bufferReady = false;
            return;
         }
         IntPtr dest = new IntPtr(pData);
         Mem.Copy(dest, concat.sharedMem, lSize);
         System.Diagnostics.Debug.WriteLine("copied shared to dest");
         concat.bufferReady = false;
      }
   }
}