using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using Leadtools.Multimedia;
using LMVCallbackLib;

namespace ConcatUsingCallback
{
   public class Concatenate : System.Windows.Forms.Form
   {

      private MainFrm gMainForm;
      private ConvCallbkSrc lmvConvCallbkSrc = new ConvCallbkSrc();
      private ConvCallbkDest lmvConvCallbkDest = new ConvCallbkDest();
      public bool bufferReady = false;
      public IntPtr sharedMem = IntPtr.Zero;
      public int memSize = -1;
      private ILMVCallback lmvCallBkSource;
      private ILMVCallback lmvCallBkDest;
      public bool gbStop;
      private ConvertCtrl convertCtrlSrc;
      private ConvertCtrl convertCtrlDest;
      private int gListCount;
      #region  Windows Form Designer generated code 

      public Concatenate(MainFrm x) : base()
      {
         gMainForm = x;

         //This call is required by the Windows Form Designer.
         InitializeComponent();

         //Add any initialization after the InitializeComponent() call

      }

      private void AddFiltersSource(object pCallback, int w, int h)
      {
         try
         {
            if (lmvCallBkSource == null)
            {
               //make sure all input videos have equal dimensions
               convertCtrlSrc.SelectedVideoProcessors.Add(convertCtrlSrc.VideoProcessors.Resize);
               LMVResizeLib.ILMVResize resize = convertCtrlSrc.GetSubObject(ConvertObject.SelVideoProcessor + 0) as LMVResizeLib.ILMVResize;
               resize.StretchMode = LMVResizeLib.StretchModeConstants.STRETCHMODE_STRETCH;
               resize.Width = w;
               resize.Height = h;
               resize.Enabled = true;
               //make sure input videos have same video type
               convertCtrlSrc.SelectedVideoProcessors.Add(convertCtrlSrc.VideoProcessors.RGBConverter);
               LMVConvRGBLib.ILMVConvRGB ConvRgb = convertCtrlSrc.GetSubObject(ConvertObject.SelVideoProcessor + 1) as LMVConvRGBLib.ILMVConvRGB;
               ConvRgb.SetOutputType((int)LMVConvRGBLib.LM_MEDIATYPES.LM_MEDIATYPE_RGB24, 0);
               //now add the callback after the other filters
               convertCtrlSrc.SelectedVideoProcessors.Add(convertCtrlSrc.VideoProcessors.Callback);
               lmvCallBkSource = convertCtrlSrc.GetSubObject(ConvertObject.SelVideoProcessor + 2) as ILMVCallback;
               lmvCallBkSource.ReceiveProcObj = pCallback;

            }
            else
            {
               lmvCallBkSource.ReceiveProcObj = pCallback;
            }
         }
         catch (Exception ex)
         {
            MessageBox.Show(ex.Message);
         }
      }

      private void AddCallbackDest(object pCallback)
      {
         try
         {
            if (lmvCallBkDest == null)
            {
               convertCtrlDest.SelectedVideoProcessors.Add(convertCtrlDest.VideoProcessors.Callback);
               lmvCallBkDest = convertCtrlDest.GetSubObject(ConvertObject.SelVideoProcessor) as ILMVCallback;
               lmvCallBkDest.ReceiveProcObj = pCallback;
            }
            else
            {
               lmvCallBkDest.ReceiveProcObj = pCallback;
            }
         }
         catch (Exception ex)
         {
            MessageBox.Show(ex.Message);
         }
      }

      //Form overrides dispose to clean up the component list.
      protected override void Dispose(bool disposing)
      {
         if (disposing)
         {
            if (components != null)
            {
               components.Dispose();
            }
         }
         base.Dispose(disposing);
      }

      //Required by the Windows Form Designer
      private System.ComponentModel.IContainer components;

      //NOTE: The following procedure is required by the Windows Form Designer
      //It can be modified using the Windows Form Designer.  
      //Do not modify it using the code editor.
      internal System.Windows.Forms.TextBox TxtStatus;
      internal System.Windows.Forms.Button BtnCancel;
      internal System.Windows.Forms.Timer Timer1;
      [System.Diagnostics.DebuggerStepThrough()]
      private void InitializeComponent()
      {
         this.components = new System.ComponentModel.Container();
         System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Concatenate));
         this.TxtStatus = new System.Windows.Forms.TextBox();
         this.BtnCancel = new System.Windows.Forms.Button();
         this.Timer1 = new System.Windows.Forms.Timer(this.components);
         this.convertCtrlSrc = new Leadtools.Multimedia.ConvertCtrl();
         this.convertCtrlDest = new Leadtools.Multimedia.ConvertCtrl();
         ((System.ComponentModel.ISupportInitialize)(this.convertCtrlSrc)).BeginInit();
         ((System.ComponentModel.ISupportInitialize)(this.convertCtrlDest)).BeginInit();
         this.SuspendLayout();
         // 
         // TxtStatus
         // 
         this.TxtStatus.BackColor = System.Drawing.SystemColors.Control;
         this.TxtStatus.Location = new System.Drawing.Point(12, 12);
         this.TxtStatus.Name = "TxtStatus";
         this.TxtStatus.ReadOnly = true;
         this.TxtStatus.Size = new System.Drawing.Size(376, 20);
         this.TxtStatus.TabIndex = 0;
         // 
         // BtnCancel
         // 
         this.BtnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
         this.BtnCancel.Location = new System.Drawing.Point(164, 68);
         this.BtnCancel.Name = "BtnCancel";
         this.BtnCancel.Size = new System.Drawing.Size(67, 23);
         this.BtnCancel.TabIndex = 1;
         this.BtnCancel.Text = "Cancel";
         this.BtnCancel.Click += new System.EventHandler(this.BtnCancel_Click);
         // 
         // Timer1
         // 
         this.Timer1.Tick += new System.EventHandler(this.Timer1_Tick);
         // 
         // convertCtrlSrc
         // 
         this.convertCtrlSrc.AudioCompressors.Selection = -1;
         this.convertCtrlSrc.Location = new System.Drawing.Point(36, 70);
         this.convertCtrlSrc.Name = "convertCtrlSrc";
         this.convertCtrlSrc.OcxState = null;
         this.convertCtrlSrc.Size = new System.Drawing.Size(10, 10);
         this.convertCtrlSrc.SourceFile = null;
         this.convertCtrlSrc.TabIndex = 2;
         this.convertCtrlSrc.TargetDevices.Selection = -1;
         this.convertCtrlSrc.TargetFile = null;
         this.convertCtrlSrc.Text = "convertCtrl1";
         this.convertCtrlSrc.VideoCompressors.Selection = -1;
         this.convertCtrlSrc.WMProfile.Description = "";
         this.convertCtrlSrc.WMProfile.Name = "";
         // 
         // convertCtrlDest
         // 
         this.convertCtrlDest.AudioCompressors.Selection = -1;
         this.convertCtrlDest.Location = new System.Drawing.Point(78, 71);
         this.convertCtrlDest.Name = "convertCtrlDest";
         this.convertCtrlDest.OcxState = null;
         this.convertCtrlDest.Size = new System.Drawing.Size(10, 10);
         this.convertCtrlDest.SourceFile = null;
         this.convertCtrlDest.TabIndex = 3;
         this.convertCtrlDest.TargetDevices.Selection = -1;
         this.convertCtrlDest.TargetFile = null;
         this.convertCtrlDest.Text = "convertCtrl1";
         this.convertCtrlDest.VideoCompressors.Selection = -1;
         this.convertCtrlDest.WMProfile.Description = "";
         this.convertCtrlDest.WMProfile.Name = "";
         // 
         // Concatenate
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.ClientSize = new System.Drawing.Size(400, 103);
         this.Controls.Add(this.convertCtrlDest);
         this.Controls.Add(this.convertCtrlSrc);
         this.Controls.Add(this.BtnCancel);
         this.Controls.Add(this.TxtStatus);
         this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
         this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
         this.MaximizeBox = false;
         this.Name = "Concatenate";
         this.Text = "Concatenating...";
         this.Load += new System.EventHandler(this.Concatenate_Load);
         ((System.ComponentModel.ISupportInitialize)(this.convertCtrlSrc)).EndInit();
         ((System.ComponentModel.ISupportInitialize)(this.convertCtrlDest)).EndInit();
         this.ResumeLayout(false);
         this.PerformLayout();

      }

      #endregion

      private void Concatenate_Load(object sender, System.EventArgs e)
      {
         gbStop = false;
         TxtStatus.Text = "Ready...";
         Timer1.Interval = 400;
         Timer1.Enabled = true;
      }

      private void Timer1_Tick(object sender, System.EventArgs e)
      {
         Timer1.Enabled = false;
         //MousePointer = 11
         DoConcatenate();
         //MousePointer = 0
         if (gbStop)
            MessageBox.Show("Canceled");
         else
            MessageBox.Show("Done!");
         this.Close();
      }

      private bool sourceFileDone;
      void convertCtrlSrc_Complete(object sender, EventArgs e)
      {
         sourceFileDone = true;
      }

      private void DoConcatenate()
      {
         gListCount = gMainForm.TreeView1.Nodes.Count;
         if (gbStop == true)
         {
            return;
         }

         lmvConvCallbkDest.concat = this;
         lmvConvCallbkSrc.concat = this;
         Leadtools.Multimedia.MediaInfo info = new MediaInfo();
         int totalFrames = 0;
         int w = 0, h = 0;
         //get input videos info
         foreach (TreeNode CurNode in gMainForm.TreeView1.Nodes)
         {
            info.SourceFile = CurNode.Text;
            totalFrames += info.VideoFrames;
            if (CurNode == gMainForm.TreeView1.Nodes[0])//first video
            {
               w = info.VideoWidth;
               h = info.VideoHeight;
               memSize = w * h * 3;
               sharedMem = System.Runtime.InteropServices.Marshal.AllocHGlobal(memSize);
            }
            info.ResetSource();
         }

         Image bmp = new Bitmap(w, h, System.Drawing.Imaging.PixelFormat.Format24bppRgb);
         string tmpImageFile = System.IO.Path.GetTempFileName() + ".png";
         bmp.Save(tmpImageFile, System.Drawing.Imaging.ImageFormat.Png);
         bmp.Dispose();
         convertCtrlDest.SourceFile = tmpImageFile;
         AddCallbackDest(lmvConvCallbkDest);
         lmvCallBkDest.CallInSameThread = false;
         convertCtrlDest.VideoCompressors.H264.Selected = true;
         convertCtrlDest.TargetFormat = gMainForm.gDesiredOutputFormat;
         convertCtrlDest.TargetFile = gMainForm.TxtDestFile.Text;
         LTStlImgRdLib.LTStlImgRd reader = convertCtrlDest.GetSubObject(ConvertObject.SourceFilter) as LTStlImgRdLib.LTStlImgRd;
         reader.Loop = totalFrames;
         reader.FrameRateControl = true;
         foreach (TreeNode CurNode in gMainForm.TreeView1.Nodes)
         {
            convertCtrlSrc.SourceFile = CurNode.Text;
            AddFiltersSource(lmvConvCallbkSrc, w, h);

            lmvCallBkSource.CallInSameThread = false;
            convertCtrlSrc.TargetFormat = TargetFormatType.NULL;
            sourceFileDone = false;
            convertCtrlSrc.Complete += new EventHandler(convertCtrlSrc_Complete);

            if (CurNode == gMainForm.TreeView1.Nodes[0])//first video
               convertCtrlDest.StartConvert();
            Application.DoEvents();
            convertCtrlSrc.StartConvert();

            while (!sourceFileDone)
            {
               System.Threading.Thread.Sleep(5);
               TxtStatus.Text = "Converting file: " + CurNode.Text + "... " + convertCtrlSrc.PercentComplete.ToString() + "% done";
               if (gbStop || convertCtrlSrc.PercentComplete == 100)
               {
                  Application.DoEvents();
                  sourceFileDone = true;
               }
               Application.DoEvents();
            }

            TxtStatus.Text = "Finished file: " + CurNode.Text;
            System.Threading.Thread.Sleep(100);
            convertCtrlSrc.Complete -= new EventHandler(convertCtrlSrc_Complete);

            if (gbStop)
            {
               Application.DoEvents();
               break;
            }
            else
            {
               convertCtrlSrc.StopConvert();
               convertCtrlSrc.ResetSource();
               System.Diagnostics.Debug.WriteLine("after convertCtrlSrc.ResetSource() " + convertCtrlSrc.State.ToString());
            }
         }
         ResetConversion();

         

         Application.DoEvents();
         while(System.IO.File.Exists(tmpImageFile))
         {
            System.Diagnostics.Debug.WriteLine("trying to delete " + tmpImageFile);
            try
            {
               System.IO.File.Delete(tmpImageFile);
            }
            catch(Exception)
            {
               System.Diagnostics.Debug.WriteLine("failed to delete " + tmpImageFile);
            }
         }
         System.Runtime.InteropServices.Marshal.FreeHGlobal(sharedMem);

         convertCtrlDest.StopConvert();
         convertCtrlDest.ResetSource();
         convertCtrlDest.ResetTarget();
      }


      private void BtnCancel_Click(object sender, System.EventArgs e)
      {
         TxtStatus.Text = "Stopping ...";
         gbStop = true;
      }
      private void ResetConversion()
      {
         /*
         convertCtrlDest.StopConvert();
         convertCtrlDest.ResetTarget();
         convertCtrlDest.ResetSource();

         convertCtrlSrc.ResetTarget();
         convertCtrlSrc.ResetSource();
         convertCtrlSrc.StopConvert();
         */
      }

   }
}
